#targetengine "hwjeventlistener"

var __hwj_eventlog__ = [];

function checkFootnotes() {
  var myDocument = app.activeDocument;
  if (myDocument == null) return;
  for (var i = 0; i < myDocument.stories.length; i++) {
    for (var j = 0; j < myDocument.stories[i].footnotes.length; j++) {
      try {
        var b = myDocument.stories[i].footnotes[j].characters[0].baseline;
      } catch(e) {
        __hwj_eventlog__.push("脚注消失?: " + myDocument.stories[i].footnotes[j].contents);
      } 
    }
  }
}

function getTwo(num) {
  return ("00" + String(num)).substr(-2);
}

var myEventListener = app.eventListeners.add("afterSave",
  function(myEvent) {
    __hwj_eventlog__ = [];
    app.scriptPreferences.userInteractionLevel = UserInteractionLevels.INTERACT_WITH_ALL;
    checkFootnotes();

    if (__hwj_eventlog__.length > 0) {
      var msg = __hwj_eventlog__.join("\n");
      var answer;
      if (msg.length > 200) {
        answer = confirm("問題を見つけました(長いので表示できません)。ログを保存しますか?", true);
      } else {
        answer = confirm("以下の問題を見つけました。ログを保存しますか?\n" + msg, true);
      }
      if (answer) {
        var d = new Date();
        var reportday = d.getFullYear() + getTwo(d.getMonth() + 1) + getTwo(d.getDate()) + getTwo(d.getHours()) + getTwo(d.getMinutes());
        var fileObj = new File("~/Desktop/indesign-check-" + reportday + ".txt");
        fileObj.encoding = "UTF8";
        fileObj.lineFeed = "Unix";
        fileObj.open("w");
        fileObj.write(msg + "\n");
        fileObj.close();
        alert("デスクトップの indesign-check-" + reportday + ".txt に保存しました。");
      }
    }
    return true;
  });
